'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * LiskHQ/lisky
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Copyright © 2017 Lisk Foundation
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * See the LICENSE file at the top-level directory of this distribution
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * for licensing information.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Unless otherwise agreed in a custom licensing agreement with the Lisk Foundation,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * no part of this software, including this file, may be copied, modified,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * propagated, or distributed except according to the terms contained in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * LICENSE file.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Removal or modification of this copyright notice is prohibited.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          */


var _cryptoModule = require('../utils/cryptoModule');

var _cryptoModule2 = _interopRequireDefault(_cryptoModule);

var _options = require('../utils/options');

var _options2 = _interopRequireDefault(_options);

var _print = require('../utils/print');

var _helpers = require('../utils/helpers');

var _input = require('../utils/input');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var decryptDescription = 'Decrypt an encrypted message from a given sender public key for a known nonce using your secret passphrase.\n\n\tExample: decrypt message bba7e2e6a4639c431b68e31115a71ffefcb4e025a4d1656405dfdcd8384719e0 349d300c906a113340ff0563ef14a96c092236f331ca4639 e501c538311d38d3857afefa26207408f4bf7f1228\n';

var handlePassphrase = function handlePassphrase(vorpal, nonce, senderPublicKey) {
	return function (_ref) {
		var _ref2 = _slicedToArray(_ref, 2),
		    passphrase = _ref2[0],
		    data = _ref2[1];

		return _cryptoModule2.default.decryptMessage(data, nonce, passphrase, senderPublicKey);
	};
};

var decrypt = function decrypt(vorpal) {
	return function (_ref3) {
		var message = _ref3.message,
		    nonce = _ref3.nonce,
		    senderPublicKey = _ref3.senderPublicKey,
		    options = _ref3.options;

		var passphraseSource = options.passphrase;
		var messageSource = options.message;

		return (message || messageSource ? (0, _input.getStdIn)({
			passphraseIsRequired: passphraseSource === 'stdin',
			dataIsRequired: messageSource === 'stdin'
		}) : Promise.reject({ message: 'No message was provided.' })).then(function (stdIn) {
			return Promise.all([(0, _input.getPassphrase)(vorpal, options.passphrase, stdIn.passphrase), (0, _input.getData)(message, messageSource, stdIn.data)]);
		}).then(handlePassphrase(vorpal, nonce, senderPublicKey)).catch((0, _helpers.createErrorHandler)('Could not decrypt message')).then((0, _print.printResult)(vorpal, options));
	};
};

function decryptCommand(vorpal) {
	var _vorpal$command$optio, _vorpal$command$optio2, _vorpal$command$optio3, _vorpal$command;

	(_vorpal$command$optio = (_vorpal$command$optio2 = (_vorpal$command$optio3 = (_vorpal$command = vorpal.command('decrypt message <senderPublicKey> <nonce> [message]')).option.apply(_vorpal$command, _toConsumableArray(_options2.default.passphrase))).option.apply(_vorpal$command$optio3, _toConsumableArray(_options2.default.message))).option.apply(_vorpal$command$optio2, _toConsumableArray(_options2.default.json))).option.apply(_vorpal$command$optio, _toConsumableArray(_options2.default.noJson)).description(decryptDescription).action(decrypt(vorpal));
}

exports.default = decryptCommand;