'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * LiskHQ/lisky
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Copyright © 2017 Lisk Foundation
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * See the LICENSE file at the top-level directory of this distribution
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * for licensing information.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Unless otherwise agreed in a custom licensing agreement with the Lisk Foundation,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * no part of this software, including this file, may be copied, modified,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * propagated, or distributed except according to the terms contained in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * LICENSE file.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Removal or modification of this copyright notice is prohibited.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          */


var _cryptoModule = require('../utils/cryptoModule');

var _cryptoModule2 = _interopRequireDefault(_cryptoModule);

var _options = require('../utils/options');

var _options2 = _interopRequireDefault(_options);

var _print = require('../utils/print');

var _helpers = require('../utils/helpers');

var _input = require('../utils/input');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var PASSWORD_DISPLAY_NAME = 'your password';

var description = 'Decrypt your secret passphrase using a password. You need the initialisation vector (IV) output at the time of encryption.\n\n\tExample: decrypt passphrase f74d6bc3bc68c9798213ee80444149e8 09dfba9040a1f2cc0b622dae18a158558b82f5ee953ece4e1ca43b8e81b15a7a\n';

var passphraseOptionDescription = 'Specifies a source for providing an encrypted passphrase to the command. If a string is provided directly as an argument, this option will be ignored. The encrypted passphrase must be provided via an argument or via this option. Sources must be one of `file` or `stdin`. In the case of `file`, a corresponding identifier must also be provided.\n\n\tNote: if both an encrypted passphrase and the password are passed via stdin, the password must be the first line.\n\n\tExamples:\n\t- --passphrase file:/path/to/my/encrypted_passphrase.txt (takes the first line only)\n\t- --passphrase stdin (takes the first line only)\n';

var handleInput = function handleInput(iv) {
	return function (_ref) {
		var _ref2 = _slicedToArray(_ref, 2),
		    cipher = _ref2[0],
		    password = _ref2[1];

		return _cryptoModule2.default.decryptPassphrase({ cipher: cipher, iv: iv }, password);
	};
};

var decryptPassphrase = function decryptPassphrase(vorpal) {
	return function (_ref3) {
		var iv = _ref3.iv,
		    passphrase = _ref3.passphrase,
		    options = _ref3.options;

		var passphraseSource = options.passphrase;
		var passwordSource = options.password;

		return (passphrase || passphraseSource ? (0, _input.getStdIn)({
			passphraseIsRequired: passwordSource === 'stdin',
			dataIsRequired: passphraseSource === 'stdin'
		}) : Promise.reject({ message: 'No passphrase was provided.' })).then(function (stdIn) {
			return Promise.all([(0, _input.getData)(passphrase, passphraseSource, (0, _input.getFirstLineFromString)(stdIn.data)), (0, _input.getPassphrase)(vorpal, passwordSource, stdIn.passphrase, {
				displayName: PASSWORD_DISPLAY_NAME
			})]);
		}).then(handleInput(iv)).catch((0, _helpers.createErrorHandler)('Could not decrypt passphrase')).then((0, _print.printResult)(vorpal, options));
	};
};

function decryptPassphraseCommand(vorpal) {
	var _vorpal$command$optio, _vorpal$command$optio2, _vorpal$command;

	(_vorpal$command$optio = (_vorpal$command$optio2 = (_vorpal$command = vorpal.command('decrypt passphrase <iv> [passphrase]')).option.apply(_vorpal$command, _toConsumableArray(_options2.default.password)).option(_options2.default.passphrase[0], passphraseOptionDescription)).option.apply(_vorpal$command$optio2, _toConsumableArray(_options2.default.json))).option.apply(_vorpal$command$optio, _toConsumableArray(_options2.default.noJson)).description(description).action(decryptPassphrase(vorpal));
}

exports.default = decryptPassphraseCommand;