'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * LiskHQ/lisky
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Copyright © 2017 Lisk Foundation
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * See the LICENSE file at the top-level directory of this distribution
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * for licensing information.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Unless otherwise agreed in a custom licensing agreement with the Lisk Foundation,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * no part of this software, including this file, may be copied, modified,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * propagated, or distributed except according to the terms contained in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * LICENSE file.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Removal or modification of this copyright notice is prohibited.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          */


var _cryptoModule = require('../utils/cryptoModule');

var _cryptoModule2 = _interopRequireDefault(_cryptoModule);

var _options = require('../utils/options');

var _options2 = _interopRequireDefault(_options);

var _print = require('../utils/print');

var _helpers = require('../utils/helpers');

var _input = require('../utils/input');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var PASSWORD_DISPLAY_NAME = 'your password';

var description = 'Encrypt your secret passphrase under a password.\n\n\tExample: encrypt passphrase\n';

var outputPublicKeyOption = ['--output-public-key', 'Includes the public key in the output. This option is provided for the convenience of node operators.'];

var handleInput = function handleInput(outputPublicKey) {
	return function (_ref) {
		var _ref2 = _slicedToArray(_ref, 2),
		    passphrase = _ref2[0],
		    password = _ref2[1];

		var cipherAndIv = _cryptoModule2.default.encryptPassphrase(passphrase, password);
		return outputPublicKey ? Object.assign({}, cipherAndIv, {
			publicKey: _cryptoModule2.default.getKeys(passphrase).publicKey
		}) : cipherAndIv;
	};
};

var encryptPassphrase = function encryptPassphrase(vorpal) {
	return function (_ref3) {
		var options = _ref3.options;
		var passphraseSource = options.passphrase,
		    passwordSource = options.password,
		    outputPublicKey = options['output-public-key'];


		return (0, _input.getStdIn)({
			passphraseIsRequired: passphraseSource === 'stdin',
			dataIsRequired: passwordSource === 'stdin'
		}).then(function (stdIn) {
			return (0, _input.getPassphrase)(vorpal, passphraseSource, stdIn.passphrase, { shouldRepeat: true }).then(function (passphrase) {
				return (0, _input.getPassphrase)(vorpal, passwordSource, (0, _input.getFirstLineFromString)(stdIn.data), { displayName: PASSWORD_DISPLAY_NAME, shouldRepeat: true }).then(function (password) {
					return [passphrase, password];
				});
			});
		}).then(handleInput(outputPublicKey)).catch((0, _helpers.createErrorHandler)('Could not encrypt passphrase')).then((0, _print.printResult)(vorpal, options));
	};
};

function encryptPassphraseCommand(vorpal) {
	var _vorpal$command$optio, _vorpal$command$optio2, _vorpal$command$optio3, _vorpal$command$optio4, _vorpal$command;

	(_vorpal$command$optio = (_vorpal$command$optio2 = (_vorpal$command$optio3 = (_vorpal$command$optio4 = (_vorpal$command = vorpal.command('encrypt passphrase')).option.apply(_vorpal$command, outputPublicKeyOption)).option.apply(_vorpal$command$optio4, _toConsumableArray(_options2.default.passphrase))).option.apply(_vorpal$command$optio3, _toConsumableArray(_options2.default.password))).option.apply(_vorpal$command$optio2, _toConsumableArray(_options2.default.json))).option.apply(_vorpal$command$optio, _toConsumableArray(_options2.default.noJson)).description(description).action(encryptPassphrase(vorpal));
}

exports.default = encryptPassphraseCommand;